'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactVirtualized = require('react-virtualized');

var _RowSelection = require('../RowSelection');

var _RowSelection2 = _interopRequireDefault(_RowSelection);

var _NoRows = require('../NoRows');

var _NoRows2 = _interopRequireDefault(_NoRows);

var _ListGrid = require('./ListGrid.scss');

var _ListGrid2 = _interopRequireDefault(_ListGrid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * List renderer that accepts a custom row renderer.
 * The row renderer will create a row element for each collection item.
 */
var ListGrid = function (_React$Component) {
	_inherits(ListGrid, _React$Component);

	function ListGrid() {
		_classCallCheck(this, ListGrid);

		return _possibleConstructorReturn(this, (ListGrid.__proto__ || Object.getPrototypeOf(ListGrid)).apply(this, arguments));
	}

	_createClass(ListGrid, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    children = _props.children,
			    id = _props.id,
			    height = _props.height,
			    isSelected = _props.isSelected,
			    rowHeight = _props.rowHeight,
			    rowRenderer = _props.rowRenderer,
			    selectionToggle = _props.selectionToggle,
			    width = _props.width;


			var enhancedRowRenderer = rowRenderer;
			if (selectionToggle) {
				enhancedRowRenderer = (0, _RowSelection2.default)(rowRenderer, {
					isSelected: isSelected,
					getRowData: function getRowData(_ref) {
						var index = _ref.index;
						return _this2.props.collection[index];
					}
				});
			}

			return _react2.default.createElement(
				_reactVirtualized.List,
				{
					className: _ListGrid2.default['tc-list-list'],
					collection: this.props.collection,
					id: id,
					height: height,
					overscanRowCount: 10,
					noRowsRenderer: _NoRows2.default,
					rowCount: this.props.collection.length,
					rowHeight: rowHeight,
					rowRenderer: enhancedRowRenderer,
					rowGetter: function rowGetter(index) {
						return _this2.props.collection[index];
					},
					width: width
				},
				children
			);
		}
	}]);

	return ListGrid;
}(_react2.default.Component);

ListGrid.displayName = 'VirtualizedList(ListGrid)';
ListGrid.propTypes = {
	children: _react.PropTypes.arrayOf(_react.PropTypes.element),
	collection: _react.PropTypes.arrayOf(_react.PropTypes.object),
	height: _react.PropTypes.number,
	id: _react.PropTypes.string,
	isSelected: _react.PropTypes.func,
	rowHeight: _react.PropTypes.number,
	rowRenderer: _react.PropTypes.func,
	selectionToggle: _react.PropTypes.func,
	width: _react.PropTypes.number
};

ListGrid.defaultProps = {
	rowHeight: 135
};

exports.default = ListGrid;